#!/usr/bin/env python
#Author: Mark Feineigle
#Create Date: 2018/03/14
#Last Modify: 2018/03/14
# Mastering Machine Learning with Python in Six Steps page 341
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
# Document Term Matrix (Bag of words)
#
# count the occurrence of words in a document without giving importance to the
# grammar and the order of words.
import os
from sklearn.feature_extraction.text import CountVectorizer
# Function to create a dictionary with key as file names
# and values as text for all files in a given folder
def CorpusFromDir(dir_path):
  result = dict(docs = [open(os.path.join(dir_path,f)).read() for f in
    os.listdir(dir_path)], ColNames = map(lambda x: x, os.listdir(dir_path)))
  return result

docs = CorpusFromDir("/home/egg/bts/")
# Initialize
vectorizer = CountVectorizer()
doc_vec = vectorizer.fit_transform(docs.get('docs'))
#create dataFrame
df = pd.DataFrame(doc_vec.toarray().transpose(), index =
vectorizer.get_feature_names())
# Change column headers to be file names
df.columns = docs.get('ColNames')
#print df[-20:]



# Create document term matrix with
# Term Frequency-Inverse Document Frequency (TF-IDF)
#
# TF-IDF is a good statistical measure to reflect the relevance of the term to
# the document in a collection of documents or corpus.
#
# Term frequency will tell you how frequently a given term appears.
# TF(term) = (number of times term appears in a doc)/(total terms in that doc)
#
# Document frequency tells you how important a term is.
# DF(term) = d(number of docs containing term)/D(size of the collection of docs)
# to normalize, take log(d/D)
#
# Inverse Document Frequency is simply the log of inverse of DF(term)
# IDF(term) = log(D/d)
#
# TF-IDF is the weight product of quantities, that is,
# TF-IDF(term) = TF * IDF
from sklearn.feature_extraction.text import TfidfVectorizer
vectorizer = TfidfVectorizer()
doc_vec = vectorizer.fit_transform(docs.get('docs'))
#create dataFrame
df = pd.DataFrame(doc_vec.toarray().transpose(),
                  index = vectorizer.get_feature_names())
# Change column headers to be file names
df.columns = docs.get('ColNames')
print df



#NOTE FUCKING PIECE OF SHIT BOOK!!!!! 90% of the code doesn't work!!!!!
#words = df.index
#freq = df.ix[:,0]#.sort(ascending=False, inplace=False) #omg another fucked up function!
#pos = np.arange(len(words))
#width=1.0
#ax=plt.axes(frameon=True)
#ax.set_xticks(pos)
#ax.set_xticklabels(words, rotation='vertical', fontsize=9)
#ax.set_title('Word Frequency Chart')
#ax.set_xlabel('Words')
#ax.set_ylabel('Frequency')
#plt.bar(pos, freq, width, color='b')
#plt.show()


#NOTE FUCKING PIECE OF SHIT BOOK! None of the code works!!!!!
#import statsmodels.api as sm
#import scipy.sparse as sp
## default unigram model
#count_model = CountVectorizer(ngram_range=(1,1))
#docs_unigram =count_model.fit_transform(docs.get('docs'))
## co-occurrence matrix in sparse csr format
#docs_unigram_matrix = (docs_unigram.T * docs_unigram)
## fill same word cooccurence to 0
#docs_unigram_matrix.setdiag(0)  #NOTE omg another failing snippet!
## co-occurrence matrix in sparse csr format
#docs_unigram_matrix = (docs_unigram.T * docs_unigram)
#docs_unigram_matrix_diags = sp.diags(1./docs_unigram_matrix.diagonal())
## normalized co-occurence matrix
#docs_unigram_matrix_norm = docs_unigram_matrix_diags * docs_unigram_matrix
## Convert to a dataframe
#df = pd.DataFrame(docs_unigram_matrix_norm.todense(),
#                  index = count_model.get_feature_names())
#df.columns = count_model.get_feature_names()
## Plot
#sm.graphics.plot_corr(df, title='Co-occurrence Matrix', xnames=list(df.index))
#plt.show()







